Subject: bug#69085: 29.2; Tramp: Extend tramp-make-copy-program-file-name via tramp-methods

From: Sean Devlin <[email-masked]>
Date: Tue, 13 Feb 2024 15:18:08 -0500

Hi Michael,

> On Feb 13, 2024, at 7:18 AM, Michael Albinus <[email-masked]> wrote:
> 
> Sean Devlin <[email-masked]> writes:
> 
>> Hi Michael,
> 
> Hi Sean,
> 
>> The copy parameters for my method look like so:
>> 
>> (defconst tramp-mymethod
>>  '("mymethod"
>>    ...
>> 
>>    (tramp-copy-program “my-copy-program")
>>    (tramp-copy-args
>>     ((“-id" "%h")))))
>> 
>> Invocations of the copy program look like:
>> 
>> my-copy-program -id HOST SRC-FILE DEST-FILE
>> 
>> The HOST is not a DNS name in this case; instead, it’s an identifier
>> for a sort of
>> abstract container.
>> 
>> For SRC-FILE and DEST-FILE, “remote” file paths just have a fixed
>> prefix string,
>> i.e. it’s not dependent on the “host” name or the user.
>> 
>> So all I really need is a way to format “remote” file paths like:
>> 
>> (format "myprefix:%s" localname)
> 
> Hmm. Some questions:
> 
> - What if SRC-FILE or DEST-FILE is local, and the other one is remote?
>  Would it still be something like "my-copy-program -id HOST SRC-FILE DEST-FILE"?

This is the main supported use case. One of the files must be local, and the other
must be “remote” (i.e. it’s inside the container HOST).

The path for the local file is formatted just like a typical local file path.

For the “remote” file, it’s formatted like a local file path but with a constant prefix in
front. The prefix is just a fixed string, and it’s just there to tell the copy program that
the path is inside the container.

> 
> - In case both SRC-FILE and DEST-FILE are remote, are they always files
>  on the same remote host identified as HOST? Or do you need also a copy
>  between two different hosts, using "mymethod"?

Direct copying between two hosts/containers isn’t supported with this program. To
handle this case, you need to copy from one remote to the local system, and then
copy that file into the second remote.

Based on my experiments, it seems that Tramp handles this scenario correctly and
uses the local system as an intermediate stop.

> 
> - And if HOST is a kind of container, would it be possible for you to
>  use the "docker" or "podman" method of Tramp directly?

I’ve looked a little bit at the code supporting these methods in tramp-container.el.
They seem similar, but not exactly the same. Also, they do not support OOB
copying, at least in the version of Tramp I’m reading (i.e. the version packaged with
Emacs 29.2).

Thanks for your help!

>> Thanks for your help!
> Best regards, Michael.